  MEMBER

  INCLUDE('ButtonClass.inc'),ONCE

  MAP
    MODULE('Windows.DLL')
      GetWindowRect(HWND, *RECT),PASCAL,RAW
    END
  END

CAIMenuButton.Construct PROCEDURE
  CODE
  SELF.MBQ &= NEW MenuButtonQueue

CAIMenuButton.Destruct PROCEDURE
  CODE
  DISPOSE(SELF.MBQ)

CAIMenuButton.Init PROCEDURE(LONG pButton,<STRING pDefaultCaption>,<STRING pDefaultIcon>)
  CODE
  SELF.ButtonHandle = pButton{Prop:Handle}
  SELF.ButtonControl = pButton
  CLEAR(SELF.Rectangle)
  IF OMITTED(pDefaultCaption)
    SELF.DefaultCaption = SELF.ButtonControl{Prop:Text}
  ELSE
    SELF.DefaultCaption = CLIP(pDefaultCaption)
  END
  IF OMITTED(pDefaultIcon)
    SELF.DefaultIcon = SELF.ButtonControl{Prop:Icon}
  ELSE
    SELF.DefaultIcon = CLIP(pDefaultIcon)
  END
  FREE(SELF.MBQ)
  SELF.NoPopup = False

CAIMenuButton.AddItem PROCEDURE(BYTE pSequence,STRING pCaption,<STRING pSmallIcon>,<STRING pShortCaption>,<STRING pIcon>)
  CODE
  SELF.MBQ.Sequence = pSequence
  GET(SELF.MBQ,SELF.MBQ.Sequence)
  IF NOT ERRORCODE()
    ASSERT(False,'Menu entry sequence not unique')
  END
  CLEAR(SELF.MBQ)
  SELF.MBQ.Caption = CLIP(pCaption)
  IF NOT OMITTED(pIcon)
    SELF.MBQ.SmallIcon = CLIP(pSmallIcon)
  END
  IF NOT OMITTED(pShortCaption)
    SELF.MBQ.ShortCaption = CLIP(pShortCaption)
  END
  IF NOT OMITTED(pICon)
    SELF.MBQ.Icon = CLIP(pIcon)
  END
  SELF.MBQ.Sequence = pSequence
  ADD(SELF.MBQ,SELF.MBQ.Sequence)

CAIMenuButton.SetVisibility PROCEDURE
  CODE
  EXECUTE RECORDS(SELF.MBQ) + 1
    SELF.ButtonControl{Prop:Hide} = True ! No selections: hide button
    BEGIN                                ! One selection: no menu
      GET(SELF.MBQ,1)
      ASSERT(NOT ERRORCODE(),'Popup choice does not exist')
      IF SELF.MBQ.ShortCaption
        SELF.ButtonControl{Prop:Text} = SELF.MBQ.ShortCaption
      ELSE
        SELF.ButtonControl{Prop:Text} = SELF.MBQ.Caption
      END
      IF SELF.MBQ.Icon
        SELF.ButtonControl{Prop:Icon} = SELF.MBQ.Icon
      ELSE
        SELF.ButtonControl{Prop:Icon} = ''
      END
      SELF.NoPopup = True
      SELF.ButtonControl{Prop:Hide} = False
    END
  ELSE
    BEGIN                                ! More than one selection: menu
      SELF.ButtonControl{Prop:Text} = SELF.DefaultCaption
      SELF.ButtonControl{Prop:Icon} = SELF.DefaultIcon
      SELF.ButtonControl{Prop:Hide} = False
      SELF.NoPopup = False
      DISPLAY(SELF.ButtonControl)
    END
  END

CAIMenuButton.Popup PROCEDURE
ControlID  LONG
MenuString CSTRING(1001)
MenuChoice BYTE
xpos       LONG
ypos       LONG
width      LONG
height     LONG
ix         BYTE
  CODE
  IF SELF.NoPopup
    GET(SELF.MBQ,1)
    ASSERT(NOT ERRORCODE(),'Popup choice does not exist')
  ELSE
    ControlID = CREATE(0,Create:Group)
    ControlID{Prop:Text} = ''
    ControlID{Prop:Boxed} = True
    ControlID{Prop:Bevel,1} = -1
    ControlID{Prop:Scroll} = True
    GETPOSITION(SELF.ButtonControl,xpos,ypos,width,height)
    SETPOSITION(ControlID,xpos,ypos,width,height)
    GetWindowRect(SELF.ButtonHandle,SELF.Rectangle)
    MenuString = ''
    LOOP ix = 1 TO RECORDS(SELF.MBQ)
      GET(SELF.MBQ,ix)
      IF ix > 1; MenuString = MenuString & '|';END
      IF SELF.MBQ.Icon
        MenuString = MenuString & '[' & PROP:Icon & '('& | 
                                   SELF.MBQ.SmallIcon&')]'&SELF.MBQ.Caption
      ELSE
        MenuString = MenuString & SELF.MBQ.Caption
      END
    END
    UNHIDE(ControlID)
    MenuChoice = POPUP(MenuString,SELF.Rectangle.Left,SELF.Rectangle.Bottom)
    DESTROY(ControlID)
    IF MenuChoice
      GET(SELF.MBQ,MenuChoice)
      ASSERT(NOT ERRORCODE(),'Popup choice does not exist')
    ELSE
      SELF.MBQ.Sequence = 0
    END
  END
  RETURN(SELF.MBQ.Sequence)

